// Karma configuration
// Generated on Fri Apr 11 2014 11:05:09 GMT+0200 (CEST)

/* eslint-env node */

module.exports = function (config) {

    'use strict';

    config.set({

        // base path that will be used to resolve all patterns (eg. files, exclude)
        basePath: 'build/',
        builddir: 'build/',

        browserNoActivityTimeout: 50000, // default: 10000

        // frameworks to use
        // available frameworks: https://npmjs.org/browse/keyword/karma-adapter
        frameworks: ['mocha', 'requirejs', 'chai', 'sinon'],

        // list of files / patterns to load in the browser
        files: [
            '../node_modules/underscore/underscore.js',
            '../bower_components/jquery/dist/jquery.js',
            'spec/lib/**/*.js',
            'spec/test-all.js',
            { pattern: 'apps/**/*.@(json|js)', included: false }, // Pattern explanation, see: https://realguess.net/tags/minimatch/
            { pattern: 'spec/globals/**/*.js', included: false },
            { pattern: 'spec/**/*_spec.js', included: false }
        ],

        // list of files to exclude
        exclude: [
        ],

        // preprocess matching files before serving them to the browser
        // available preprocessors: https://npmjs.org/browse/keyword/karma-preprocessor
        preprocessors: {
        },

        // test results reporter to use
        // possible values: 'dots', 'progress', 'junit', 'growl', 'coverage'
        // available reporters: https://npmjs.org/browse/keyword/karma-reporter
        reporters: ['progress'],

        // web server port
        port: 9876,

        // enable / disable colors in the output (reporters and logs)
        colors: true,

        // level of logging
        // possible values: config.LOG_DISABLE || config.LOG_ERROR || config.LOG_WARN || config.LOG_INFO || config.LOG_DEBUG
        logLevel: config.LOG_ERROR,

        // enable / disable watching file and executing tests whenever any file changes
        autoWatch: false,

        // start these browsers
        // available browser launchers: https://npmjs.org/browse/keyword/karma-launcher
        browsers: ['PhantomJS'],

        // Continuous Integration mode
        // if true, Karma captures browsers, runs the tests and exits
        singleRun: false
    });
};
